VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "vbGL Ejemplo 3 (Texture Coord Array)"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Pict 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   750
      Left            =   240
      ScaleHeight     =   50
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   56
      TabIndex        =   0
      Top             =   510
      Visible         =   0   'False
      Width           =   840
   End
   Begin VB.Menu mnuContextual 
      Caption         =   "Contextual"
      Visible         =   0   'False
      Begin VB.Menu mnuLighting 
         Caption         =   "&Lighting"
      End
      Begin VB.Menu mnuWireframe 
         Caption         =   "Wireframe"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'-------------------------------------------------------------------------------------------
'Author           : Paul Dahuach
'Year             : 2008
'Legal            : Do whatever you want with it, send me some feedback if you want.
'More Examples    : http://www.pauldahuach.com.ar/program_en.htm
'Dependencies     : vbGL.tlb (http://home.pacific.net.hk/~edx/tlb.htm)
'-------------------------------------------------------------------------------------------

' TGA-specific data structures
Private Type TGAHEADER
    idLength        As Byte
    colorMapType    As Byte
    imageType       As Byte
    colorMapSpec(4) As Byte
    xOrigin         As Integer
    yOrigin         As Integer
    width           As Integer
    height          As Integer
    bpp             As Byte
    imageDesc       As Byte
End Type

Private Type vec2_t
    st(2)                       As Single
End Type

Private Type vec3_t
    xyz(2)                      As Single
End Type

Private Type vec4_t
    xyzw(3)                     As Single
End Type

Private Type camera_t
    origin                      As vec3_t
    Velocity(2)                 As Single
    angles(2)                   As Single
    ViewHeight                  As Single
    MaxJumpHeight               As Single
End Type

Private Type renderCommand
    startVertex                 As Long
    vertexCount                 As Long
    textureIdx                  As Long
End Type

Private vertexCount             As Long
Private Vertices()              As vec3_t
Private Normals()               As vec3_t
Private Colors()                As vec4_t
Private texCoords()             As vec2_t
Private textureIdx()            As Long
Private renderCommands()        As renderCommand
Private textureId(255)          As Long
Private cmdCount                As Long

Private camera                  As camera_t
Private Fps                     As Double
Private OldTick                 As Long
Private SystemFrame             As Long
Private wireframe               As Boolean
Private colTest                 As Long
Private GetAsyncKeyState(255)   As Long

Private blnUnload               As Boolean
Private hRC                     As Long
Private AspectRadio             As Double
Private pfd                     As PIXELFORMATDESCRIPTOR
Private iFormat                 As Long

Private Sub Form_Load()
    Dim ff As Integer
    
    If blnUnload Then Exit Sub
    
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    pfd.dwFlags = PFD_DRAW_TO_WINDOW Or _
                  PFD_SUPPORT_OPENGL Or _
                  PFD_DOUBLEBUFFER
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 32
    pfd.cDepthBits = 24
    pfd.cStencilBits = 8
    pfd.cAccumBits = 0
    pfd.iLayerType = PFD_MAIN_PLANE
    iFormat = ChoosePixelFormat(hDC, pfd)
    Call SetPixelFormat(hDC, iFormat, pfd)
    hRC = wglCreateContext(hDC)
    wglMakeCurrent hDC, hRC
    
    'MoveWindow Me.hWnd, 0, 0, 640 + 8, 480 + 27, False
    Me.Show
    Me.Refresh
    
    glClearColor 0.1, 0.2, 0.5, 0
    glShadeModel GL_SMOOTH
    glEnable GL_DEPTH_TEST
    glDepthFunc GL_LEQUAL
    glEnable GL_CULL_FACE
    glCullFace GL_FRONT

    textureId(0) = loadTextureTGA(App.Path & "\wall.tga")
    textureId(1) = loadTextureTGA(App.Path & "\ground.tga")
    textureId(2) = loadTextureTGA(App.Path & "\roof.tga")
    
    ' Load Map
    ff = FreeFile
    Open App.Path & "\Vertices.sng" For Binary As ff
    vertexCount = LOF(ff) / (4 * 3)
    ReDim Vertices(vertexCount - 1)
    ReDim Normals(vertexCount - 1)
    ReDim Colors(vertexCount - 1)
    ReDim texCoords(vertexCount - 1)
    ReDim textureIdx(vertexCount - 1)
    ReDim renderCommands(vertexCount / 3 - 1)
    
    Get ff, , Vertices()
    Close ff
    
    Open App.Path & "\Normals.sng" For Binary As ff
    Get ff, , Normals()
    Close ff
    
    Open App.Path & "\Colors.sng" For Binary As ff
    Get ff, , Colors()
    Close ff
    
    Open App.Path & "\TexCoords.sng" For Binary As ff
    Get ff, , texCoords()
    Close ff
    
    Open App.Path & "\TextureId.sng" For Binary As ff
    Get ff, , textureIdx()
    Close ff
    
    Dim i As Long
    Dim j As Long
    renderCommands(0).textureIdx = -1
    For i = 0 To UBound(textureIdx)
        Colors(i).xyzw(0) = 1
        Colors(i).xyzw(1) = 1
        Colors(i).xyzw(2) = 1
        Colors(i).xyzw(3) = 1
        If renderCommands(j).textureIdx <> textureIdx(i) _
           Then
               j = j + 1
               renderCommands(j).startVertex = i
        End If
        renderCommands(j).textureIdx = textureIdx(i)
        renderCommands(j).vertexCount = renderCommands(j).vertexCount + 1
    Next
    cmdCount = j
    
    With camera
         .ViewHeight = 40
         .origin.xyz(0) = -128
         .origin.xyz(1) = 0 + .ViewHeight
         .origin.xyz(2) = 0
    End With

    Do Until GetAsyncKeyState(vbKeyEscape) <> 0 Or blnUnload
       DoEvents
       If blnUnload Then Exit Do
       updateFps
       moveAround
       Call Display
       draw2D Fps
       SwapBuffers Me.hDC
    Loop
    
    wglMakeCurrent 0, 0
    wglDeleteContext hRC
    
    End
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    'Slow, but fine for now
    GetAsyncKeyState(KeyCode) = 1
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    GetAsyncKeyState(KeyCode) = 0
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbRightButton _
       Then
           PopupMenu Me.mnuContextual, , x, y
    End If
End Sub

Private Sub Form_Resize()
    If Me.WindowState = vbMinimized Then Exit Sub
    AspectRadio = Me.ScaleWidth / Me.ScaleHeight
    glViewport 0, 0, Me.ScaleWidth, Me.ScaleHeight
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluPerspective 60, AspectRadio, 0.1, 10000
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
End Sub

Private Sub Form_Unload(Cancel As Integer)
    blnUnload = True
End Sub

Private Sub LogToFile(texto As String)
    Dim ff As Integer
    ff = FreeFile
    Open App.Path & "\Log.txt" For Append As #ff
    Print #ff, texto
    Close #ff
End Sub

Private Sub draw2D(fpsRate As Double)
    Dim dummy   As Byte
    Dim buffer  As String
    Dim c       As Long
    glPushMatrix
      glLoadIdentity
      glMatrixMode GL_PROJECTION
      glPushMatrix
        glLoadIdentity
        glOrtho 0, 1, 1, 0, -1, 1
        glDisable GL_DEPTH_TEST
        glColor3f 1, 1, 1
        
        glRasterPos2f 1, 1
        glBitmap 0, 0, 0, 0, -50, 10, dummy
        buffer = "fps " & Format$(fpsRate, "#0.0")
        For c = 1 To Len(buffer)
            glutBitmapCharacter GLUT_BITMAP_HELVETICA_10, Asc(Mid(buffer, c, 1))
        Next
        
        glEnable GL_DEPTH_TEST
      glPopMatrix
      glMatrixMode GL_MODELVIEW
    glPopMatrix
End Sub

Private Sub updateFps()
    Static maxFrames      As Long
    Static frameCount     As Long
    Static oldCount       As Currency
    Static newCount       As Currency
    Static frequency      As Currency
    Static blnStarted     As Boolean
    
    If Not blnStarted _
       Then
           maxFrames = 60
           QueryPerformanceFrequency frequency
           frameCount = 0
           Fps = 0
           blnStarted = True
    End If
    
    frameCount = frameCount + 1
    SystemFrame = GetTickCount - OldTick
    OldTick = GetTickCount
    If frameCount >= maxFrames _
       Then
           QueryPerformanceCounter newCount
           Fps = maxFrames * frequency / (newCount - oldCount)
           QueryPerformanceCounter oldCount
           frameCount = 0
    End If
End Sub

Private Function timeElapsed() As Long
    timeElapsed = SystemFrame / 10
End Function

Private Sub moveAround()
    Const StepAmount As Single = 50
    Const TurnAmount As Single = 20
    Dim PosAnt       As vec3_t
    Dim PosNew       As vec3_t
    
    PosAnt.xyz(0) = camera.origin.xyz(0)
    PosAnt.xyz(1) = camera.origin.xyz(1)
    PosAnt.xyz(2) = camera.origin.xyz(2)
    PosNew.xyz(1) = PosAnt.xyz(1)
    
    ' Walk
    If GetAsyncKeyState(vbKeyUp) <> 0 Or GetAsyncKeyState(vbKeyW) <> 0 _
       Then ' Move Forward
           camera.Velocity(2) = camera.Velocity(2) + StepAmount * timeElapsed / 10
           If camera.Velocity(2) > StepAmount _
              Then
                  camera.Velocity(2) = StepAmount
           End If
    End If
    If GetAsyncKeyState(vbKeyDown) <> 0 Or GetAsyncKeyState(vbKeyS) <> 0 _
       Then ' Move backward
           camera.Velocity(2) = camera.Velocity(2) - StepAmount * timeElapsed / 10
           If camera.Velocity(2) < -StepAmount _
              Then
                  camera.Velocity(2) = -StepAmount
           End If
    End If
    camera.Velocity(2) = camera.Velocity(2) * 0.55
    PosNew.xyz(0) = PosAnt.xyz(0) + Cos(camera.angles(1)) * camera.Velocity(2)
    PosNew.xyz(2) = PosAnt.xyz(2) + Sin(camera.angles(1)) * camera.Velocity(2)

    'Girar
    If GetAsyncKeyState(vbKeyLeft) <> 0 Or GetAsyncKeyState(vbKeyA) <> 0 _
       Then ' Turn Left
           camera.Velocity(1) = camera.Velocity(1) - 1 * timeElapsed / TurnAmount
           If camera.Velocity(1) < -TurnAmount _
              Then
                  camera.Velocity(1) = -TurnAmount
           End If
    End If
    If GetAsyncKeyState(vbKeyRight) <> 0 Or GetAsyncKeyState(vbKeyD) <> 0 _
       Then ' Turn Right
           camera.Velocity(1) = camera.Velocity(1) + 1 * timeElapsed / TurnAmount
           If camera.Velocity(1) > TurnAmount _
              Then
                  camera.Velocity(1) = TurnAmount
           End If
    End If
    camera.Velocity(1) = camera.Velocity(1) * 0.5
    camera.angles(1) = camera.angles(1) + camera.Velocity(1)

    'Look up/down
    If GetAsyncKeyState(vbKeyQ) <> 0 _
       Then 'Look up
           camera.Velocity(0) = camera.Velocity(0) + 0.75 * timeElapsed / 12
           If camera.angles(0) > 1.5 _
              Then
                  camera.angles(0) = 1.5
           End If
    End If
    If GetAsyncKeyState(vbKeyZ) <> 0 _
       Then 'Look Down
           camera.Velocity(0) = camera.Velocity(0) - 0.75 * timeElapsed / 12
           If camera.angles(0) < -1.5 _
              Then
                  camera.angles(0) = -1.5
           End If
    End If
    camera.Velocity(0) = camera.Velocity(0) * 0.5
    camera.angles(0) = camera.angles(0) + camera.Velocity(0)
    
    If GetAsyncKeyState(vbKeySubtract) <> 0 _
       Then ' Fly
           PosNew.xyz(1) = PosAnt.xyz(1) + timeElapsed * 1.5
    End If
    If GetAsyncKeyState(vbKeyAdd) <> 0 _
       Then ' Land
           PosNew.xyz(1) = PosAnt.xyz(1) - timeElapsed * 1.5
    End If
    If GetAsyncKeyState(vbKeyX) <> 0 _
       Then ' On your knees
           camera.ViewHeight = 20
       Else
           camera.ViewHeight = 40
    End If
    camera.origin = PosNew
    
    'Set the camera origin and look at point
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluPerspective 60, AspectRadio, 0.1, 10000
    gluLookAt camera.origin.xyz(0), _
              camera.origin.xyz(1), _
              camera.origin.xyz(2), _
              camera.origin.xyz(0) + Cos(camera.angles(1)), _
              camera.origin.xyz(1) + Sin(camera.angles(0)), _
              camera.origin.xyz(2) + Sin(camera.angles(1)), 0, 1, 0
    glMatrixMode GL_MODELVIEW

End Sub

Private Sub mnuLighting_Click()
    If Me.mnuLighting.Checked _
       Then
           Me.mnuLighting.Checked = False
           glDisable GL_LIGHTING
       Else
           Me.mnuLighting.Checked = True
           glEnable GL_LIGHTING
    End If
End Sub

Private Sub mnuWireframe_Click()
    If Me.mnuWireframe.Checked _
       Then
           Me.mnuWireframe.Checked = False
           glPolygonMode GL_FRONT_AND_BACK, GL_FILL
       Else
           Me.mnuWireframe.Checked = True
           glPolygonMode GL_FRONT_AND_BACK, GL_LINE
    End If
End Sub

Function loadTextureTGA(filename As String) As Long
    ' Loads a Targa, extracts the data from it, and places it in a texture
    ' object associated with textureID.
    On Error GoTo Hell
    
    Const TGA_NODATA                As Byte = 0
    Const TGA_INDEXEDED             As Byte = 1
    Const TGA_RGB                   As Byte = 2
    Const TGA_GRAYSCALE             As Byte = 3
    Const TGA_INDEXED_RLE           As Byte = 9
    Const TGA_RGB_RLE               As Byte = 10
    Const TGA_GRAYSCALE_RLE         As Byte = 11
    
    Const GL_TEXTURE0               As Long = &H84C0&
    Const GL_TEXTURE1               As Long = &H84C1&
    Const GL_COMPRESSED_RGB_ARB     As Long = &H84ED&
    Const GL_COMPRESSED_RGBA_ARB    As Long = &H84EE&
    
    Dim textureId       As Long
    Dim pFile           As Integer
    Dim tga             As TGAHEADER
    Dim colorMode       As Long
    Dim imageSize       As Long
    Dim pData()         As Byte
    Dim dataFormat      As Long
    Dim internalformat  As Long
    Dim lngRet          As Long
    
    ' open the TGA file
    pFile = FreeFile
    
    If Dir(filename) = vbNullString _
       Then
           LogToFile "Texture Lost: " & filename
           Exit Function
    End If
    
    Open filename For Binary As #pFile
    
    ' read in the image type
    Get #pFile, , tga
    
    ' see if the type is one that we support
    If (tga.imageType <> TGA_RGB) And _
       (tga.imageType <> TGA_GRAYSCALE) _
       Then
           Close #pFile
           Exit Function
    End If
    
    ' if colorMode is 3, there is no alpha channel
    colorMode = tga.bpp / 8
    imageSize = tga.width
    imageSize = imageSize * tga.height
    imageSize = imageSize * colorMode
    
    ReDim pData(imageSize - 1)
    
    ' read image data
    Get #pFile, , pData
      
    ' close the file
    Close #pFile
    
    ' choose the proper data formats depending on whether or not there's an
    ' alpha channel
    
    dataFormat = IIf(colorMode = 3, GL_BGR_EXT, GL_BGRA_EXT)
    
    If colorMode = 3 _
       Then
           internalformat = GL_COMPRESSED_RGB_ARB
           'internalformat = GL_RGB
       Else
           internalformat = GL_COMPRESSED_RGBA_ARB
           'internalformat = GL_RGBA
    End If
    
    glGenTextures 1, textureId
    glBindTexture GL_TEXTURE_2D, textureId
    
    glPixelTransferf GL_RED_SCALE, 1
    glPixelTransferf GL_GREEN_SCALE, 1
    glPixelTransferf GL_BLUE_SCALE, 1
    
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT

    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR
    
    lngRet = gluBuild2DMipmaps(GL_TEXTURE_2D, internalformat, tga.width, tga.height, dataFormat, GL_UNSIGNED_BYTE, VarPtr(pData(0)))
    If lngRet <> 0 _
       Then
           LogToFile "Error gluBuild2DMipmaps"
    End If
    Erase pData
    If glIsTexture(textureId) _
       Then
           loadTextureTGA = textureId
    End If
    
    Exit Function
Hell:
    LogToFile "LoadTextureTGA(" & filename & "): " & Err.Description
End Function

Private Sub Display()
    glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
    glLoadIdentity
    If vertexCount > 0 _
       Then
           Dim i As Long
           For i = 1 To cmdCount
               glEnable GL_TEXTURE_2D
               glBindTexture glTexture2D, textureId(renderCommands(i).textureIdx)
               glTexEnvi GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE
               
               glEnableClientState GL_VERTEX_ARRAY
               glEnableClientState GL_NORMAL_ARRAY
               glEnableClientState GL_COLOR_ARRAY
               glEnableClientState GL_TEXTURE_COORD_ARRAY
               
               glVertexPointer 3, GL_FLOAT, 0, Vertices(0).xyz(0)
               glNormalPointer GL_FLOAT, 0, Normals(0).xyz(0)
               glColorPointer 3, GL_FLOAT, 16, Colors(0).xyzw(0)
               glTexCoordPointer 2, GL_FLOAT, 8, texCoords(0).st(0)
               glDrawArrays GL_TRIANGLES, renderCommands(i).startVertex, renderCommands(i).vertexCount
               
               glDisableClientState GL_VERTEX_ARRAY
               glDisableClientState GL_NORMAL_ARRAY
               glDisableClientState GL_COLOR_ARRAY
               glDisableClientState GL_TEXTURE_COORD_ARRAY
               glDisable GL_TEXTURE_2D
           Next
    End If
End Sub
